org.bdgenomics.adam.rdd.fragment

# FragmentRDD

###
Related Docs: object FragmentRDD | package fragment

#### sealed abstract class FragmentRDD extends AvroRecordGroupGenomicDataset[Fragment, Fragment, FragmentRDD]

Linear Supertypes
AvroRecordGroupGenomicDataset[Fragment, Fragment, FragmentRDD], GenomicDatasetWithLineage[Fragment, Fragment, FragmentRDD], AvroGenomicDataset[Fragment, Fragment, FragmentRDD], GenomicDataset[Fragment, Fragment, FragmentRDD], Logging, AnyRef, Any
Known Subclasses
DatasetBoundFragmentRDD, ParquetUnboundFragmentRDD, RDDBoundFragmentRDD
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. FragmentRDD
2. AvroRecordGroupGenomicDataset
3. GenomicDatasetWithLineage
4. AvroGenomicDataset
5. GenomicDataset
6. Logging
7. AnyRef
8. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract val dataset: Dataset[Fragment]

   These data as a Spark SQL Dataset.

   These data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset

2. #### abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

   Attributes
     protected
   Definition Classes
     GenomicDataset

3. #### abstract val processingSteps: Seq[ProcessingStep]

   The processing steps that have been applied to this GenomicDataset.

   The processing steps that have been applied to this GenomicDataset.

   Definition Classes
     GenomicDatasetWithLineage

4. #### abstract val rdd: RDD[Fragment]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicDataset

5. #### abstract val recordGroups: RecordGroupDictionary

   A dictionary describing the record groups attached to this GenomicDataset.

   A dictionary describing the record groups attached to this GenomicDataset.

   Definition Classes
     AvroRecordGroupGenomicDataset

6. #### abstract def replaceProcessingSteps(newProcessingSteps: Seq[ProcessingStep]): FragmentRDD

   Replaces the processing steps attached to this RDD.

   Replaces the processing steps attached to this RDD.

   newProcessingSteps

     The new processing steps to attach to this RDD.

   returns

     Returns a new GenomicDataset with new processing lineage attached.

   Definition Classes
     GenomicDatasetWithLineage

7. #### abstract def replaceRecordGroups(newRecordGroups: RecordGroupDictionary): FragmentRDD

   Replaces the record groups attached to this RDD.

   Replaces the record groups attached to this RDD.

   newRecordGroups

     The new record group dictionary to attach.

   returns

     Returns a new GenomicDataset with new record groups attached.

   Definition Classes
     AvroRecordGroupGenomicDataset

8. #### abstract def replaceSequences(newSequences: SequenceDictionary): FragmentRDD

   Replaces the sequence dictionary attached to a GenomicDataset.

   Replaces the sequence dictionary attached to a GenomicDataset.

   newSequences

     The new sequence dictionary to attach.

   returns

     Returns a new GenomicDataset with the sequences replaced.

   Definition Classes
     GenomicDataset

9. #### abstract val sequences: SequenceDictionary

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   Definition Classes
     GenomicDataset

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def addProcessingStep(newProcessingStep: ProcessingStep): FragmentRDD

   Merges a new processing record with the extant computational lineage.

   Merges a new processing record with the extant computational lineage.

   returns

     Returns a new GenomicDataset with new record groups merged in.

   Definition Classes
     GenomicDatasetWithLineage

5. #### def addRecordGroup(recordGroupToAdd: RecordGroup): FragmentRDD

   Adds a single record group to the extant record groups.

   Adds a single record group to the extant record groups.

   recordGroupToAdd

     The record group to append to the extant record groups.

   returns

     Returns a new GenomicDataset with the new record group added.

   Definition Classes
     AvroRecordGroupGenomicDataset

6. #### def addRecordGroups(recordGroupsToAdd: RecordGroupDictionary): FragmentRDD

   Merges a new set of record groups with the extant record groups.

   Merges a new set of record groups with the extant record groups.

   recordGroupsToAdd

     The record group dictionary to append to the extant record groups.

   returns

     Returns a new GenomicDataset with new record groups merged in.

   Definition Classes
     AvroRecordGroupGenomicDataset

7. #### def addSequence(sequenceToAdd: SequenceRecord): FragmentRDD

   Appends metadata for a single sequence to the current RDD.

   Appends metadata for a single sequence to the current RDD.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicDataset with this sequence appended.

   Definition Classes
     GenomicDataset

8. #### def addSequences(sequencesToAdd: SequenceDictionary): FragmentRDD

   Appends sequence metadata to the current RDD.

   Appends sequence metadata to the current RDD.

   sequencesToAdd

     The new sequences to append.

   returns

     Returns a new GenomicDataset with the sequences appended.

   Definition Classes
     GenomicDataset

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def binQualityScores(bins: Seq[QualityScoreBin]): FragmentRDD

    Rewrites the quality scores of fragments to place all quality scores in bins.

    Rewrites the quality scores of fragments to place all quality scores in bins.

    Quality score binning maps all quality scores to a limited number of discrete values, thus reducing the entropy of the quality score distribution, and reducing the amount of space that fragments consume on disk.

    bins

      The bins to use.

    returns

      Fragments whose quality scores are binned.

11. #### def broadcast()(implicit tTag: ClassTag[Fragment]): GenomicBroadcast[Fragment, Fragment, FragmentRDD]

    Definition Classes
      GenomicDataset

12. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Y)]): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

13. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Y)]): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainst

14. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. Python/Java friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

15. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

16. #### def broadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Y, Fragment)]): GenericGenomicDataset[(X, Fragment), (Y, Fragment)]

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

17. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], Fragment)]): GenericGenomicDataset[(Iterable[X], Fragment), (Seq[Y], Fragment)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

18. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Fragment], Y)]): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

19. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Fragment], Y)]): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

20. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

21. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

22. #### def buildTree(rdd: RDD[(ReferenceRegion, Fragment)])(implicit tTag: ClassTag[Fragment]): IntervalArray[ReferenceRegion, Fragment]

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicDataset

23. #### def cache(): FragmentRDD

    Caches underlying RDD in memory.

    Caches underlying RDD in memory.

    returns

      Cached GenomicDataset.

    Definition Classes
      GenomicDataset

24. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

26. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

27. #### def filterByOverlappingRegion(query: ReferenceRegion): FragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the query region.

    Definition Classes
      GenomicDataset

28. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): FragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions. Java friendly version.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

29. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): FragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

30. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

31. #### def flattenRddByRegions(): RDD[(ReferenceRegion, Fragment)]

    Attributes
      protected
    Definition Classes
      GenomicDataset

32. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Fragment], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Option[Y])]): GenericGenomicDataset[(Option[Fragment], Option[X]), (Option[Fragment], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

33. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Fragment], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Option[Y])]): GenericGenomicDataset[(Option[Fragment], Option[X]), (Option[Fragment], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

34. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Fragment], Option[X]), (Option[Fragment], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

35. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Fragment], Option[X]), (Option[Fragment], Option[Y])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

36. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

37. #### def getReferenceRegions(elem: Fragment): Seq[ReferenceRegion]

    Returns the regions that this fragment covers.

    Returns the regions that this fragment covers.

    Since a fragment may be chimeric or multi-mapped, we do not try to compute the hull of the underlying element.

    elem

      The Fragment to get the region from.

    returns

      Returns all regions covered by this fragment.

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicDataset

38. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

39. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

40. #### def isSorted: Boolean

    Definition Classes
      GenomicDataset

41. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

42. #### lazy val jrdd: JavaRDD[Fragment]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicDataset

43. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Option[Y])]): GenericGenomicDataset[(Fragment, Option[X]), (Fragment, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

44. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Option[Y])]): GenericGenomicDataset[(Fragment, Option[X]), (Fragment, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

45. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Fragment, Option[X]), (Fragment, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

46. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Fragment, Option[X]), (Fragment, Option[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

47. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Seq[Y])]): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

48. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Seq[Y])]): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

49. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

50. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicDataset

51. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

52. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

53. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

54. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

55. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

56. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

57. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

58. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

59. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

60. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

61. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

62. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

63. #### def markDuplicates(): FragmentRDD

    Marks reads as possible fragment duplicates.

    Marks reads as possible fragment duplicates.

    returns

      A new RDD where reads have the duplicate read flag set. Duplicate reads are NOT filtered out.

64. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

65. #### final def notify(): Unit

    Definition Classes
      AnyRef

66. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

67. #### def persist(sl: StorageLevel): FragmentRDD

    Persists underlying RDD in memory or disk.

    Persists underlying RDD in memory or disk.

    sl

      new StorageLevel

    returns

      Persisted GenomicDataset.

    Definition Classes
      GenomicDataset

68. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Fragment, Fragment, FragmentRDD, W]](cmd: List[String], files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[FragmentRDD, RDD[X], Z]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Java/PySpark friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

69. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Fragment, Fragment, FragmentRDD, W]](cmd: Seq[Any], files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[FragmentRDD, RDD[X], Z]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    SparkR friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

70. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Fragment, Fragment, FragmentRDD, W]](cmd: Seq[String], files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0, optTimeout: Option[Int] = None)(implicit tFormatterCompanion: InFormatterCompanion[Fragment, Fragment, FragmentRDD, W], xFormatter: OutFormatter[X], convFn: (FragmentRDD, RDD[X]) ⇒ Z, tManifest: ClassTag[Fragment], xManifest: ClassTag[X]): Z

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicDataset. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    optTimeout

      An optional parameter specifying how long to let a single partition run for, in seconds. If the partition times out, the partial results will be returned, and no exception will be logged. The partition will log that the command timed out.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

71. #### val productFn: (Fragment) ⇒ Fragment

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicDataset

72. #### def replaceRdd(newRdd: RDD[Fragment], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): FragmentRDD

    Replaces the underlying RDD with a new RDD.

    Replaces the underlying RDD with a new RDD.

    newRdd

      The RDD to replace our underlying RDD with.

    returns

      Returns a new FragmentRDD where the underlying RDD has been swapped out.

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicDataset

73. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Y)]): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

74. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Y)]): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

75. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

76. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly version.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

77. #### def rightOuterBroadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], oyuTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Y], Fragment)]): GenericGenomicDataset[(Option[X], Fragment), (Option[Y], Fragment)]

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoin

78. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], Fragment)]): GenericGenomicDataset[(Iterable[X], Fragment), (Seq[Y], Fragment)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoinAndGroupByRight

79. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Fragment], Y)]): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

80. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Fragment], Y)]): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

81. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

82. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[Fragment], X), (Seq[Fragment], Y)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

83. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Y)]): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

84. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Y)]): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

85. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

86. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Fragment], X), (Option[Fragment], Y)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicDataset

87. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[Fragment], Iterable[X])], otsyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Seq[Y])]): GenericGenomicDataset[(Option[Fragment], Iterable[X]), (Option[Fragment], Seq[Y])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicDataset

88. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[Fragment], Iterable[X])], ousyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Fragment], Seq[Y])]): GenericGenomicDataset[(Option[Fragment], Iterable[X]), (Option[Fragment], Seq[Y])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicDataset

89. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Fragment], Iterable[X]), (Option[Fragment], Seq[Y])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key. PySpark/Java friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicDataset

90. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Fragment], Iterable[X]), (Option[Fragment], Seq[Y])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key. SparkR friendly variant.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicDataset

91. #### def save(filePath: String): Unit

    Saves Fragments to Parquet.

    Saves Fragments to Parquet.

    filePath

      Path to save fragments at.

92. #### def saveAsParquet(pathName: String): Unit

    Saves this RDD to disk as a Parquet + Avro file.

    Saves this RDD to disk as a Parquet + Avro file.

    pathName

      The path to save the file to.

    Definition Classes
      AvroGenomicDataset

93. #### def saveAsParquet(pathName: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

    Saves this RDD to disk as a Parquet + Avro file.

    Saves this RDD to disk as a Parquet + Avro file.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write.

    pageSize

      The size in bytes of pages to write.

    compressCodec

      The compression codec to apply to pages.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used.

    Definition Classes
      AvroGenomicDataset

94. #### def saveAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves this RDD to disk as a Parquet + Avro file.

    Saves this RDD to disk as a Parquet + Avro file.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write.

    pageSize

      The size in bytes of pages to write.

    compressCodec

      The compression codec to apply to pages.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used.

    Definition Classes
      AvroGenomicDataset → GenomicDataset

95. #### def saveAsParquet(args: SaveArgs): Unit

    Saves an RDD to Parquet.

    Saves an RDD to Parquet.

    args

      The output format configuration to use when saving the data.

    Definition Classes
      GenomicDataset

96. #### def saveAsPartitionedParquet(pathName: String, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, partitionSize: Int = 1000000): Unit

    Saves this RDD to disk in range binned partitioned Parquet format.

    Saves this RDD to disk in range binned partitioned Parquet format.

    pathName

      The path to save the partitioned Parquet file to.

    compressCodec

      Name of the compression codec to use.

    partitionSize

      Size of partitions used when writing Parquet, in base pairs (bp). Defaults to 1,000,000 bp.

    Definition Classes
      GenomicDataset

97. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    pathName

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      GenomicDataset

98. #### def saveMetadata(pathName: String): Unit

    Writes any necessary metadata to disk.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    pathName

      The path to save metadata to.

    Attributes
      protected
    Definition Classes
      AvroRecordGroupGenomicDataset → AvroGenomicDataset → GenomicDataset

99. #### def savePartitionMap(filePath: String): Unit

    Save the partition map to disk.

    Save the partition map to disk. This is done by adding the partition map to the schema.

    filePath

      The filepath where we will save the partition map.

    Attributes
      protected
    Definition Classes
      AvroGenomicDataset

100. #### def saveProcessingSteps(pathName: String): Unit

     Save the processing steps to disk.

     Save the processing steps to disk.

     pathName

       The path to save processing steps to.

     Attributes
       protected
     Definition Classes
       AvroRecordGroupGenomicDataset

101. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

     Saves an RDD of Avro data to Parquet.

     Saves an RDD of Avro data to Parquet.

     pathName

       The path to save the file to.

     blockSize

       The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

     pageSize

       The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

     compressCodec

       The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

     disableDictionaryEncoding

       If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

     optSchema

       The optional schema to set. Defaults to None.

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

102. #### def saveRddAsParquet(args: SaveArgs): Unit

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

103. #### def saveRecordGroups(pathName: String): Unit

     Save the record groups to disk.

     Save the record groups to disk.

     pathName

       The path to save record groups to.

     Attributes
       protected
     Definition Classes
       AvroRecordGroupGenomicDataset

104. #### def saveSequences(pathName: String): Unit

     Save the sequence dictionary to disk.

     Save the sequence dictionary to disk.

     pathName

       The path to save the sequence dictionary to.

     Attributes
       protected
     Definition Classes
       GenomicDataset

105. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Y)]): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

106. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Y)]): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

107. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

108. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Fragment, X), (Fragment, Y)]

     Performs a sort-merge inner join between this RDD and another RDD.

     Performs a sort-merge inner join between this RDD and another RDD.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

109. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], tixTag: ClassTag[(Fragment, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Seq[Y])]): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

     genomicRdd

       The right RDD in the join.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

     Definition Classes
       GenomicDataset

110. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], tixTag: ClassTag[(Fragment, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Fragment, Seq[Y])]): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

     Definition Classes
       GenomicDataset

111. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. PySpark/Java friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD.

     Definition Classes
       GenomicDataset

112. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicRdd: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Fragment, Iterable[X]), (Fragment, Seq[Y])]

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

     In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. SparkR friendly variant.

     genomicRdd

       The right RDD in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD.

     Definition Classes
       GenomicDataset

113. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Fragment]): FragmentRDD

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     partitions

       The number of partitions for the new RDD.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

     See also

       sortLexicographically

114. #### def sort(): FragmentRDD

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     Sorts our genome aligned data by reference positions, with contigs ordered by index.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sortLexicographically

115. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Fragment]): FragmentRDD

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     partitions

       The number of partitions for the new RDD.

     storePartitionMap

       A Boolean flag to determine whether to store the partition bounds from the resulting RDD.

     storageLevel

       The level at which to persist the resulting RDD.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

     See also

       sort

116. #### def sortLexicographically(): FragmentRDD

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

     returns

       Returns a new RDD containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sort

117. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

118. #### def toDF(): DataFrame

     returns

       This data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset

119. #### def toReads(): AlignmentRecordRDD

     Essentially, splits up the reads in a Fragment.

     Essentially, splits up the reads in a Fragment.

     returns

       Returns this RDD converted back to reads.

120. #### def toString(): String

     Definition Classes
       AvroRecordGroupGenomicDataset → GenomicDataset → AnyRef → Any

121. #### def transform(tFn: Function[JavaRDD[Fragment], JavaRDD[Fragment]]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

122. #### def transform(tFn: (RDD[Fragment]) ⇒ RDD[Fragment]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

123. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): FragmentRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API. Java-friendly variant.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

124. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[Fragment]): FragmentRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

125. #### def transformDataset(tFn: (Dataset[Fragment]) ⇒ Dataset[Fragment]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a Dataset.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       FragmentRDD → GenomicDataset

126. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[JavaRDD[Fragment], JavaRDD[X]], convFn: Function2[FragmentRDD, RDD[X], Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly version.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

127. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (RDD[Fragment]) ⇒ RDD[X])(implicit convFn: (FragmentRDD, RDD[X]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

128. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[Fragment, Fragment, FragmentRDD, X, Y, Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

129. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (DataFrame) ⇒ DataFrame)(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (FragmentRDD, Dataset[Y]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

130. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[Dataset[Fragment], Dataset[Y]], convFn: GenomicDatasetConversion[Fragment, Fragment, FragmentRDD, X, Y, Z]): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

131. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (Dataset[Fragment]) ⇒ Dataset[Y])(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (FragmentRDD, Dataset[Y]) ⇒ Z): Z

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

132. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[Fragment]

     Definition Classes
       FragmentRDD → GenomicDataset

133. #### def union(rdds: FragmentRDD*): FragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       FragmentRDD → GenomicDataset

134. #### def union(rdds: List[FragmentRDD]): FragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       GenomicDataset

135. #### def unpersist(): FragmentRDD

     Unpersists underlying RDD from memory or disk.

     Unpersists underlying RDD from memory or disk.

     returns

       Uncached GenomicDataset.

     Definition Classes
       GenomicDataset

136. #### val unproductFn: (Fragment) ⇒ Fragment

     Attributes
       protected
     Definition Classes
       FragmentRDD → GenomicDataset

137. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

138. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

139. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

140. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicDataset

### Inherited from AvroRecordGroupGenomicDataset[Fragment, Fragment, FragmentRDD]

### Inherited from GenomicDatasetWithLineage[Fragment, Fragment, FragmentRDD]

### Inherited from AvroGenomicDataset[Fragment, Fragment, FragmentRDD]

### Inherited from GenomicDataset[Fragment, Fragment, FragmentRDD]

### Inherited from Logging

### Inherited from AnyRef

### Inherited from Any

### Ungrouped